/***

Copyright 2011-2012 Carlos Moreno Munoz

This file is part of Vands.

Vands is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Foobar is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License
along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
****/

//DECLARACION DE CLASES
function Jugador (x,y){ 
	//Propiedades
	
	//Nombre
	{% ifequal error 0 %}
		this.nombre="{{ appearance }}";
	{% else %}
		this.nombre="";
	{% endifequal %}
	
	//Cuerpo
	this.cuerpo_img=new Array();
	this.cuerpo_img[0]=new Image();
	this.cuerpo_img[0].src = URL_IMAGENES+"bodys/cuerpo.png";
	this.cuerpo_width=25*ESCALA_GENERAL;
	this.cuerpo_height=35*ESCALA_GENERAL;
	this.x=x;
	this.y=y;
	
	//Cara
	this.cara_img=new Image();
	{% ifequal error 0 %}
		this.cara_img.src=URL_IMAGENES+"faces/"+this.nombre+".jpg";
		this.cara_xref={{ appearance.face_x }}*ESCALA_GENERAL; //x respecto al cuerpo
		this.cara_yref={{ appearance.face_y }}*ESCALA_GENERAL; //y respecto al cuerpo
		this.cara_w={{ appearance.face_w }}*ESCALA_GENERAL;
		this.cara_h={{ appearance.face_h }}*ESCALA_GENERAL;
	{% else %}
		this.cara_img.src=URL_IMAGENES+"interface/noencontrado.png";
		this.cara_xref=27; //x respecto al cuerpo
		this.cara_yref=0; //y respecto al cuerpo
		this.cara_w=70;
		this.cara_h=70;	
	{% endifequal %}
	
	//Metodos
	this.getXCara=function(){return this.x+this.cara_xref;}
	this.getYCara=function(){return this.y+this.cara_yref;}
}

function Grid (){	
	this.grid=new Array(GRID_ROWS);
	
	var i,j;
	for(i=0;i<GRID_ROWS;i++){
		this.grid[i]=new Array(GRID_COLUMNS);
		for(j=0;j<GRID_COLUMNS;j++)
			this.grid[i][j]=1;
	}
}

function Boton(url,x,y,w,h){
    this.image=new Image();
    this.image.src=URL_IMAGENES+"interface/"+url+".png";
    this.over_image=new Image();
    this.over_image.src=URL_IMAGENES+"interface/"+url+"2.png";
	this.x=x;
	this.y=y;
	this.w=w;
	this.h=h;
}

function Menu(w,h){
    this.botones=new Array(2);
    this.width=w*ESCALA_GENERAL;
    this.height=h*ESCALA_GENERAL;
    this.y=0;
    
    this.estado=0;

	var coordenadas=repartir_elementos(ANCHURA_VENTANA/2,50,this.botones.length,99,w,h,20);
    this.botones[0]=new Boton("boton_habitacion",coordenadas[0][0],this.y,w,h);
    this.botones[1]=new Boton("boton_logout",coordenadas[1][0],this.y,w,h);
}

function Dialogo(x,y,w,h){
	
	this.tag={{ error }};
	this.x=x;
	this.y=y;
	this.w=w;
	this.h=h;
	this.alpha=0.0;
	this.opcion_apuntada=-1;
	this.opcion_w=100;
	this.opcion_h=50;
	if(this.tag==0)
		this.coordenadas_opciones=repartir_elementos(ANCHURA_VENTANA/2,350,2,2,this.opcion_w,this.opcion_h,50);
	else
		this.coordenadas_opciones=repartir_elementos(ANCHURA_VENTANA/2,350,1,2,this.opcion_w,this.opcion_h,50);
	this.bandname="{{ bandname }}";
	
	{% ifequal error 0 %}
		this.texto=new Texto("Quieres que \"{{ appearance }}\" forme parte de tu banda \"{{ bandname }}\"? Pulsa ACEPTAR para mandar la peticion.",400,200,200,25,AL_IZQ);
	{% else %}
		this.texto=new Texto("No se ha encontrado ningun usuario con el nombre \"{{ appearance }}\"",400,200,200,25,AL_IZQ);
	{% endifequal %}
	
}

function Texto(texto,x,y,w,m_y,al){

	var separadas=separar_palabras(texto);
	this.repartidas=repartir_texto(separadas,w);
	this.coordenadas=new Array(this.repartidas.length);
	
	var i;
	var y_linea=y-(this.repartidas.length*7.5);
	
	for(i=0;i<this.repartidas.length;i++){
		this.coordenadas[i]=new Array(2);
		if(al==AL_IZQ){
			this.coordenadas[i][0]=x-w/2;
		}else if(al==AL_DER){
			this.coordenadas[i][0]=x+w/2-contexto.measureText(this.repartidas[i]).width;
		}else if(al==AL_CEN){
			var linea_w=contexto.measureText(this.repartidas[i]).width;
			this.coordenadas[i][0]=x-linea_w/2;
		}
		this.coordenadas[i][1]=y_linea;
		y_linea+=m_y;
	}

	this.dibujar=function(x_offset,y_offset){
		for(i=0;i<this.repartidas.length;i++)
			contexto.fillText(this.repartidas[i], this.coordenadas[i][0]+x_offset, this.coordenadas[i][1]+y_offset);	
	}
}